#include "discretedataset.h"
# include <math.h>
# include <QDebug>
//fortonei ta dedomena apo csv arxeio
//sto arxeio stin proti grammi einai me komma ta onomata ton xaraktiristikon
//se kathe grammi einai ta xaraktiristika me komma kai stin teleytaia stili
//i epithymiti katigori
DiscreteDataset::DiscreteDataset(QString filename)
{
    QFile fp(filename);
    if(!fp.open(QIODevice::ReadOnly|QIODevice::Text)) return ;
    QTextStream st(&fp);
    QString ss=st.readLine();
    header=ss.split(",");
    while(true)
    {
        ss=st.readLine();
        if(ss.size()==0) break;
        QStringList list=ss.split(",");
        QStringList xlist=list.mid(0,list.size()-1);
        xpoint<<xlist;
        ypoint<<list[list.size()-1];
    }
    makeClass();
    fp.close();
}

double DiscreteDataset::entropy()
{
    double sum = 0.0;
    for(int i=0;i<classVector.size();i++)
    {
        int pc = 0;
        for(int j=0;j<ypoint.size();j++)
        {
            if(ypoint[j]==classVector[i])
                pc++;
        }
        double ppc = pc *1.0/ypoint.size();
        sum+=-ppc  * log2(ppc);
    }
    return sum;
}

double DiscreteDataset::gain(int feature)
{
    QStringList values = enumerateValues(feature);
    double hs = entropy();
    double sum=0.0;
    for(int i=0;i<values.size();i++)
    {
        QString v = values[i];
        DiscreteDataset *d = subDataset(feature,v);
        double ht = d->entropy();
        double pt = d->getpoints()*1.0/getpoints();
        sum+=pt * ht;
        delete d;
    }
    return hs-sum;
}

int DiscreteDataset::featureWithHighestGain()
{
    int indexMax=-1;
    double gainMax = -1e+100;
    for(int i=0;i<header.size()-1;i++)
    {
        double g = gain(i);
        if(g>gainMax || i==0)
        {
            indexMax=i;
            gainMax= g;
        }
    }

    return indexMax;
}

int DiscreteDataset::featureWithHighestGain(QVector<int> &list)
{
    int indexMax=-1;
    double gainMax = -1e+100;
    for(int i=0;i<header.size()-1;i++)
    {
        if(list.contains(i)) continue;
        double g = gain(i);
        if(g>gainMax || i==0)
        {
            indexMax=i;
            gainMax= g;
        }
    }

    return indexMax;
}

void    DiscreteDataset::makeClass()
{
    for(int i=0;i<ypoint.size();i++)
    {
        QString y=ypoint[i];

        if(!classVector.contains(y))
            classVector<<y;
    }
}
DiscreteDataset::DiscreteDataset(QStringList h,QVector<QStringList>xdata,QStringList ydata)
{
    header= h;
    xpoint.resize(xdata.size());
    for(int i=0;i<xdata.size();i++) xpoint[i]=xdata[i];
    ypoint=ydata;
    makeClass();
}

DiscreteDataset *DiscreteDataset::subDataset(int feature, QString value)
{
    QVector<QStringList> tempx;
    QStringList tempy;
    for(int i=0;i<xpoint.size();i++)
    {
        if(xpoint[i][feature]==value)
        {
            tempx<<xpoint[i];
            tempy<<ypoint[i];
        }
    }
    return new DiscreteDataset(header,tempx,tempy);
}

//arithmos features
int DiscreteDataset::features()
{
    return header.size()-1;
}

//epistrefei tis monadikes times tou feature
QStringList DiscreteDataset::enumerateValues(int feature)
{
    QStringList list;
    for(int i=0;i<ypoint.size();i++)
    {
        QString value=xpoint[i][feature];
        if(!list.contains(value))
            list<<value;
    }
    return list;
}

//epistrefei tin epikealida
QStringList DiscreteDataset::getheader()
{
    return header;
}

QStringList DiscreteDataset::getx(int pos)
{
    return xpoint[pos];
}

int         DiscreteDataset::getpoints()
{
     return ypoint.size();
}

int         DiscreteDataset::getfeature(QString value)
{
    for(int i=0;i<header.size();i++)
        if(header[i]==value)
            return i;
    return -1;
}


QString DiscreteDataset::gety(int pos)
{
    return ypoint[pos];
}

Pattern DiscreteDataset::getClass()
{
    return classVector;
}
