#ifndef TREE_H
#define TREE_H
# include <QVector>
# include <QStringList>
# define NODE_FEATURE 1
# define NODE_VALUE   2

/**
 * @brief The Tree class ftiaxnei dendra
 */
class Tree
{
private:
    /**
     * @brief value einai i timi tis rizas
     */
    QString value;
    /**
     * @brief type, o typos tou dendrou (feature, value)
     */
    int type;
    /**
     * @brief children ta kladia tou dendrou
     */
    QVector<Tree*> children;
public:
    /**
     * @brief Tree, synartisi dimiourgias
     * @param v
     * @param t
     */
    Tree(QString v,int t);
    /**
     * @brief nchildren, epistrefei to plithos ton kladion tou dendrou
     * @return
     */
    int     nchildren();
    /**
     * @brief getType, epistrefei ton typo tou dendrou
     * @return
     */
    int     getType();

    /**
     * @brief getChild, epistrefei to dendro stin thesi pos
     * @param pos
     * @return
     */
    Tree        *getChild(int pos);
    /**
     * @brief addChild, prosthetei neo kladi
     * @param t
     */
    void        addChild(Tree *t);
    /**
     * @brief isLeaf, epistrefei alithes an einai termatikos komvos
     * @return
     */
    bool        isLeaf();
    /**
     * @brief getvalue, epistrefei tin timi tis rizas.
     * @return
     */
    QString     getvalue();
    /**
     * @brief print, ektyponei to dendro
     */
    void        print();
    /**
     * @brief toString, epistrefei to dendro san string
     * @return
     */
    QString     toString();
};

#endif // TREE_H
